PATH := /home/tristan/Documents/emu/qemu_stm32/arm-softmmu/:$(PATH)

REP = /home/tristan/Documents/lib/libopencm3
STMFLASH = /home/tristan/Documents/stm32/ftdi_stm32_prog/stm32flash.sh

CROSS_COMPILE =arm-none-eabi-
CC		= $(CROSS_COMPILE)gcc
LD		= $(CROSS_COMPILE)ld
AR		= $(CROSS_COMPILE)ar
AS		= $(CROSS_COMPILE)as
OC		= $(CROSS_COMPILE)objcopy
OD		= $(CROSS_COMPILE)objdump
SZ		= $(CROSS_COMPILE)size

CFLAGS	= 	-c -fno-common \
		-ffunction-sections \
		-fdata-sections \
		-Os \
		-mcpu=cortex-m3 \
		-mthumb \
                -g3 \
		-DSTM32F1 \
                -DSTM32F10X_MD
#                -DSTM32F10X_LD_VL \

LDSCRIPT= ../ld/stm32vl-discovery.ld

LDFLAGS	= -L$(REP)/lib/ -lopencm3_stm32f1 --static \
	-Wl,--start-group -lc -lgcc -lnosys -Wl,--end-group \
	-T$(LDSCRIPT) -nostartfiles -Wl,--gc-sections -mthumb \
	-mcpu=cortex-m3 -msoft-float -mfix-cortex-m3-ldrd 

OCFLAGS	=	-Obinary

ODFLAGS	=	-S


OUTPUT_DIR = output

TARGET  = 	$(OUTPUT_DIR)/main


INCLUDE =   -I../\
	    -I./src/ \
	    -I../../FreeRTOS-LTS/FreeRTOS/FreeRTOS-Kernel/include/ \
	    -I../../FreeRTOS-LTS/FreeRTOS/FreeRTOS-Kernel/portable/GCC/ARM_CM3/ \
	    -I../common \
	    -I$(REP)/include/

# Add other source files if they are needed e.g. other Firmwarlib Components
SRCS	=   ./src/main.c \
	    ../common/freertos_opencm3.c \
	    ../common/usart_opencm3.c \
		../../FreeRTOS-LTS/FreeRTOS/FreeRTOS-Kernel/timers.c \
		../../FreeRTOS-LTS/FreeRTOS/FreeRTOS-Kernel/portable/MemMang/heap_2.c \
		../../FreeRTOS-LTS/FreeRTOS/FreeRTOS-Kernel/portable/GCC/ARM_CM3/port.c \
		../../FreeRTOS-LTS/FreeRTOS/FreeRTOS-Kernel/tasks.c \
		../../FreeRTOS-LTS/FreeRTOS/FreeRTOS-Kernel/queue.c \
		../../FreeRTOS-LTS/FreeRTOS/FreeRTOS-Kernel/croutine.c \
		../../FreeRTOS-LTS/FreeRTOS/FreeRTOS-Kernel/list.c 

OBJS=$(SRCS:.c=.o)

.PHONY : clean all

all: $(TARGET).bin  $(TARGET).list
	@echo "  SIZE $(TARGET).elf"
	$(SZ) $(TARGET).elf

clean:
	@echo "Removing files..."
	-find . -name '*.o'   | xargs rm
	-find ../../FreeRTOS-LTS/FreeRTOS/FreeRTOS-Kernel -name '*.o'   | xargs rm
	-find . -name '*.elf' | xargs rm
	-find . -name '*.lst' | xargs rm
	-find . -name '*.out' | xargs rm
	-find . -name '*.bin' | xargs rm
	-find . -name '*.map' | xargs rm
	rm ../common/*.o


$(TARGET).list: $(TARGET).elf
	@echo "  OBJDUMP $(TARGET).list"
	$(OD) $(ODFLAGS) $< > $(TARGET).lst



$(TARGET).bin: $(TARGET).elf
	@echo "  OBJCOPY $(TARGET).bin"
	$(OC) $(OCFLAGS) $(TARGET).elf $(TARGET).bin

$(TARGET).elf: $(OBJS) 
	@echo "  LD $(TARGET).elf"
	$(CC)  -o $(TARGET).elf $(OBJS) $(LDFLAGS)

%.o: %.c
	@echo "  CC $<"
	$(CC) $(INCLUDE) $(CFLAGS)  $< -o $*.o

%.o: %.S
	@echo "  CC $<"
	$(CC) $(INCLUDE) $(CFLAGS)  $< -o $*.o

flash: output/main.bin
	$(STMFLASH) -w output/main.bin /dev/ttyUSB0
#	st-flash write output/main.bin 0x8000000

qemu: output/main.bin
	../../../qemu/qemu_stm32/arm-softmmu/qemu-system-arm -M stm32-p103 -serial stdio -serial stdio -serial stdio -kernel output/main.bin 

